import  java.awt.Button;
import  java.awt.Color;
import  java.awt.Dimension;
import  java.awt.GridLayout;
import  java.awt.Label;
import  java.awt.Panel;
import  java.awt.event.ActionListener;
import  java.awt.event.ActionEvent;

import  model.Model;
import  model.State;

public class  Controller
extends  Panel
implements  ActionListener
{
  protected Button[]  btnNumber;
  protected Button[]  btnOperator;
  protected Button    btnEquals;
  protected Button    btnClear;
  protected Label[]   lblDummy;
  protected Model  _model;

  public  Controller(Model model) {
    _model = model;

    GridLayout  gridLayout1 = new GridLayout(4, 4);
    gridLayout1.setColumns(5);
    gridLayout1.setRows(4);
    setLayout(gridLayout1);

    btnNumber = new Button[10];
    btnOperator = new Button[4];
    lblDummy = new Label[4];
    for (int i=0 ; i<btnNumber.length ; i++) {
      btnNumber[i] = new Button(String.valueOf(i));
      btnNumber[i].addActionListener(this);
    }
    Dimension  dimension = btnNumber[0].getSize();
    dimension.width = dimension.width * 3 + 5 * 2;
    btnNumber[0].setSize(dimension);
    btnOperator[0] = new Button("/");btnOperator[0].addActionListener(this);
    btnOperator[1] = new Button("*");btnOperator[1].addActionListener(this);
    btnOperator[2] = new Button("-");btnOperator[2].addActionListener(this);
    btnOperator[3] = new Button("+");btnOperator[3].addActionListener(this);
    btnEquals      = new Button("=");btnEquals.addActionListener(this);
    btnClear       = new Button("C");btnClear.addActionListener(this);
    for (int i=0 ; i<lblDummy.length ; i++) {
      lblDummy[i] = new Label();
      lblDummy[i].setText("");
    }

    add(btnNumber[7]);
    add(btnNumber[8]);
    add(btnNumber[9]);
    add(btnOperator[0]);
    add(btnClear);

    add(btnNumber[4]);
    add(btnNumber[5]);
    add(btnNumber[6]);
    add(btnOperator[1]);
    add(lblDummy[0]);

    add(btnNumber[1]);
    add(btnNumber[2]);
    add(btnNumber[3]);
    add(btnOperator[2]);
    add(lblDummy[1]);

    add(btnNumber[0]);
    add(lblDummy[2]);
    add(btnEquals);
    add(btnOperator[3]);
    add(lblDummy[3]);

    setBackground(Color.lightGray);
  }

  // implements  ActionListener
  public void  actionPerformed(ActionEvent ev) {
    String  label = ev.getActionCommand();
    if (label.equals("C")) { _model.run(State.CLEAR);  return; }
    if (label.equals("=")) { _model.run(State.EQUALS); return; }
    if (label.equals("+")) { _model.run(State.PLUS);   return; }
    if (label.equals("-")) { _model.run(State.MINUS);  return; }
    if (label.equals("*")) { _model.run(State.MULTI);  return; }
    if (label.equals("/")) { _model.run(State.DIV);    return; }
    try {
      int  value = Integer.parseInt(label);
      _model.run(value);
    } catch(NumberFormatException e) {
      System.out.println("NumberFormatException");
    }
  }
}
